{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.MediaLive.Types.InputWhitelistRuleCidr
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.MediaLive.Types.InputWhitelistRuleCidr where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | An IPv4 CIDR to whitelist.
--
-- /See:/ 'newInputWhitelistRuleCidr' smart constructor.
data InputWhitelistRuleCidr = InputWhitelistRuleCidr'
  { -- | The IPv4 CIDR to whitelist.
    cidr :: Prelude.Maybe Prelude.Text
  }
  deriving (Prelude.Eq, Prelude.Read, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'InputWhitelistRuleCidr' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'cidr', 'inputWhitelistRuleCidr_cidr' - The IPv4 CIDR to whitelist.
newInputWhitelistRuleCidr ::
  InputWhitelistRuleCidr
newInputWhitelistRuleCidr =
  InputWhitelistRuleCidr' {cidr = Prelude.Nothing}

-- | The IPv4 CIDR to whitelist.
inputWhitelistRuleCidr_cidr :: Lens.Lens' InputWhitelistRuleCidr (Prelude.Maybe Prelude.Text)
inputWhitelistRuleCidr_cidr = Lens.lens (\InputWhitelistRuleCidr' {cidr} -> cidr) (\s@InputWhitelistRuleCidr' {} a -> s {cidr = a} :: InputWhitelistRuleCidr)

instance Prelude.Hashable InputWhitelistRuleCidr where
  hashWithSalt _salt InputWhitelistRuleCidr' {..} =
    _salt `Prelude.hashWithSalt` cidr

instance Prelude.NFData InputWhitelistRuleCidr where
  rnf InputWhitelistRuleCidr' {..} = Prelude.rnf cidr

instance Data.ToJSON InputWhitelistRuleCidr where
  toJSON InputWhitelistRuleCidr' {..} =
    Data.object
      ( Prelude.catMaybes
          [("cidr" Data..=) Prelude.<$> cidr]
      )
